:MAIN
@echo off
mode con cols=160 lines=72

cls

REM if CPU-load process runs, kill
echo.>"%cd%\tmp\TermCPUMeasure.tmp"
set OUTFILE="%cd%\tmp\tmpvid.mkv"
set LOGFILE="%cd%\tmp\x264_output.tmp"

REM // look if backup found
if exist "%cd%\System\recover.bak" (
	if exist "%cd%\System\recover.cfg" (
		del /f /q "%cd%\System\recover.cfg"
		ren "%cd%\System\recover.bak" recover.cfg
	)
)
if exist "%cd%\system\recover.cfg" (call :RECOVERMODE)
if /i "%RecovRun%"=="1" (goto :LOOP)

REM continue normal if no recovermode starts
for /f "usebackq tokens=1* delims==" %%a in ("%cd%\System\settings.cfg") do (set "%%a=%%b")
set "NUMBEROFFILES=0"
set "VIDEOFILES="
setlocal enabledelayedexpansion
for /f "delims=" %%a in ('dir /b "%cd%\VIDEOFILES\*.*"') do (
	set /a NUMBEROFFILES=NUMBEROFFILES+1
	if defined VIDEOFILES (
		set "VIDEOFILES=!VIDEOFILES!:%%a"
	) else (
		set "VIDEOFILES=%%a"
	)
)
if not "!VIDEOFILES!"=="" (
	for /f "delims= tokens=1,2" %%a in ("!VIDEOFILES!!NUMBEROFFILES!") do (endlocal & set "VIDEOFILES=%%a" & set "NUMBEROFFILES=%%b")
) else (
	endlocal & set NUMBEROFFILES=0
)
call :STATFILENAME
set /a OverallJobs = (((MAX_PSYRD-MIN_PSYRD)/STEP_PSYRD)+1)*(((MAX_PSYTR-MIN_PSYTR)/STEP_PSYTR)+1)*(((MAX_QUANT-MIN_QUANT)/STEP_QUANT)+1)*(((MAX_SUB-MIN_SUB)/STEP_SUB)+1)*(((MAX_REF-MIN_REF)/STEP_REF)+1)*(((MAX_BF-MIN_BF)/STEP_BF)+1)



color 3b
cls
echo.
call :LOGO
echo.  
echo                                                    ^<^<^< SETTINGS OF ^"\System\SETTINGS.CFG^" ^>^>^>
echo  
echo  0^)Reference-frames ^(set STEP to raise with REFLOOP^)                                  [REFFRAMES]0                       [1-16/step def=STEP][%REFFRAMES%]
echo  
echo  1^)REFLOOP - Boost reference-frames per loop                       [MIN_REF] [STEP_REF] [MAX_REF]1    [1-16 def=5] [1-15 def=1] [1-16 def=11][%REFLOOP%]
echo  
echo  2^)B-frames to use ^(STEP to raise with BFLOOP^)                                          [BFRAMES]2                       [1-16/STEP def=STEP][%BFRAMES%]
echo  
echo  3^)BFLOOP - Boost B-frames per loop                                   [MIN_BF] [STEP_BF] [MAX_BF]3     [1-16 def=3] [1-15 def=1] [1-16 def=9][%BFLOOP%]
echo  
echo  4^)Quantizat. factor ^(qp only int, STEP raises w. QUANTLOOP^)                       [QUANTIZATION]4                       [1-69/STEP def=STEP][%QUANTIZATION%]
echo  
echo  5^)QUANTLOOP - Boost quantization per loop                   [MIN_QUANT] [STEP_QUANT] [MAX_QUANT]5   [1-69 def=19] [1-68 def=1] [1-69 def=21][%QUANTLOOP%]
echo  
echo  6^)Subpixel motion est. and dec. ^(STEP to raise with SUBLOOP^)                             [SUBME]6                       [1-11/STEP def=STEP][%SUBME%]
echo  
echo  7^)SUBLOOP - Boost motion estimation per loop                      [MIN_SUB] [STEP_SUB] [MAX_SUB]7     [1-11 def=7] [1-10 def=1] [1-11 def=9][%SUBLOOP%]
echo  
echo  A^)Psy rate-dist.+trellis ^(STEP to raise w. PSYRD/PSYTRLOOP^)                             [PSY-RD]A             [0-10.00:0-10.00/step def=0:0][%PSY-RD%]
echo  
echo  B^)PSYRDLOOP - Boost psy-rate-distortion per loop ^(1=0.01^)   [MIN_PSYRD] [STEP_PSYRD] [MAX_PSYRD]B[0-1000 def=0] [1-999 def=1] [0-1000 def=0][%PSYRDLOOP%]
echo  
echo  C^)PSYTRLOOP - Boost psy-trellis per loop ^(1=0.01^)           [MIN_PSYTR] [STEP_PSYTR] [MAX_PSYTR]C[0-1000 def=0] [1-999 def=1] [0-1000 def=0][%PSYTRLOOP%]
echo  
echo  D^)Pixel motion ^(auto=umh if CPUload to low -^> use exh next^)                                 [ME]D       [DIA/HEX/UMH/ESA/TESA/AUTO def=AUTO][%ME%]
echo  
echo  E^)Pixel search range ^(auto=24 if CPUload to low -^> 32 next^)                            [MERANGE]E                      [8-512/AUTO def=AUTO][%MERANGE%]
echo  
echo  F^)Trellis quantiz. ^(auto=0 if cpu-load to low-^>2 used next^)                            [TRELLIS]F                           [0-2/AUTO def=0][%TRELLIS%]
echo  
echo  G^)Encodingmode ^(qp allows AQ-MODE 0 + AQ-STRENGTH 0^ only)                         [ENCODINGMODE]G                           [CRF/QP def=CRF][%ENCODINGMODE%]
echo  
echo  H^)Adaptive quantization mode off/manual/autoselect                                     [AQ-MODE]H                                [0-2 def=0][%AQ-MODE%]
echo  
echo  I^)Adapt. quant. strength ^(qp only AQ-MODE 0+AQ-STRENGTH 0^)                         [AQ-STRENGTH]I                              [0-2.0 def=0][%AQ-STRENGTH%]
echo  
echo  J^)Max. CPU-load before file analysis starts                                   [CPULOADTHRESHOLD]J                               [1-10 def=5][%CPULOADTHRESHOLD%]
echo  
echo  K^)Statistic-file output as csv-table/tabbed file                                  [OUTPUTFORMAT]K                          [TAB/CSV def=TAB][%OUTPUTFORMAT%]
echo  
echo  L^)Save generated videos in tmp-folder for a closer look                           [SAVETMPFILES]L                           [ON/OFF def=OFF][%SAVETMPFILES%]
echo  
echo.
if %NumberOfFiles%==0 echo      Found ^> %NumberOfFiles% ^< video-file^(s^) in ^"VIDEOFILES^"-folder!
if %NumberOfFiles% NEQ 0 echo      Found %NumberOfFiles% video-file^(s^) in ^"VIDEOFILES^"-folder!
if %NumberOfFiles% NEQ 0 echo      Current step-settings result in ^> %OverallJobs% ^< analysation jobs per file to do!
echo.
echo      STATISTICS: %STATISTICFILE%
echo.
if %NumberOfFiles% NEQ 0 echo                  Hit [RETURN] to START with current settingsͻ
if %NumberOfFiles% NEQ 0 echo                  ͼ
echo     
echo     -^>To get HELP on a setting type HELP followed by NR. of setting!        /\ 
echo     -^>To RESET settings to default type RESET!                         \/  /\  /  \
echo     -^>Use [ARROW-KEYS] to get values you typed before:                  \/       \  /
echo  
echo      To CHANGE SETTINGS, enter NR. of setting NOW followed by ^"blank^" and VALUE ^(e.g. ^"1 crf^"^) and hit [RETURN].
if "%time:~0,1%"==" " (set "TimeDisp=0%time:~1,-3%") else (set "TimeDisp=%time:~0,-3%")
if defined Message (
	echo                             ---^>%TimeDisp% - %Message%^<---
	) else (echo.)
set "Message="
Set "MenueInput="
set /p "MenueInput=>[SETTING-NR and/or RETURN]#"
call :HELP "%MenueInput%"
if "%HelpUsed%"=="1" goto :MAIN
if defined MenueInput (
call :READMENUEINPUT
goto :MAIN
)
REM /* call MenueInput again if user has not entered anything and just starts script
REM    Step-Parameters MIN+STEP+MAX will be set correctly */
set "MenueInput=ModifyStepParameters"
call :READMENUEINPUT "parameters for deactivated stepping automatically set..."
REM // Now read new corrected settings from settings.cfg
for /f "usebackq tokens=1* delims==" %%a in ("%cd%\System\settings.cfg") do (set %%a=%%b)


REM /* Auto-Correction of some Values returns to user-input !!!after!!! wrong settings have been saved
REM (otherwise user could never again set AQ-MODE=2/AQ-STRENGTH=1 after setting to 0/0) */
if /i "%ENCODINGMODE%"=="qp" (
	if not "%AQ-MODE%"=="0" (
		set "MenueInput=h 0"
		call :READMENUEINPUT "[AQ-MODE] AUTO-CORRECTION to [0]: AQ-MODE greater 0 needs ENCODINGMODE crf"
		goto :MAIN
	)
)
if /i "%ENCODINGMODE%"=="qp" (
	if not "%AQ-STRENGTH%"=="0" (
		set "MenueInput=i 0"
		call :READDMENUEINPUT "[AQ-STRENGTH] AUTO-CORRECTION to [0]: AQ-STRENGTH greater 0 needs ENCODINGMODE crf"
		goto :MAIN
	)
)

if /i "%PSY-RD%"=="step" (
	if not "%PSYRDLOOP%" == "0 1 0" (
		if not "%TRELLIS%"=="2" (
			if not "%TRELLIS%"=="1" (
				set "MenueInput=f 2"
				call :READMENUEINPUT "[TRELLIS] AUTO-CORRECTION to [2]: PSYRDLOOP different from '0 1 0' needs TRELLIS 1 or 2"
				goto :MAIN
			)
		)
	)
)
if /i "%PSY-RD%"=="step" (
	if not "%PSYTRLOOP%" == "0 1 0" (
		if not "%TRELLIS%"=="2" (
			if not "%TRELLIS%"=="1" (
				set "MenueInput=f 2"
				call :READMENUEINPUT "[TRELLIS] AUTO-CORRECTION to [2]: PSYTRLOOP different from '0 1 0' needs TRELLIS 1 or 2"
				goto :MAIN
			)
		)
	)
)
if /i not "%PSY-RD%"=="step" (
	if not "%PSY-RD%"=="0:0" (
		if not "%TRELLIS%"=="2" (
			if not "%TRELLIS%"=="1" (
				set "MenueInput=f 2"
				call :READMENUEINPUT "[TRELLIS] AUTO-CORRECTION to [2]: PSY-RD greater '0:0' needs TRELLIS 1 or 2"
				goto :MAIN
			)
		)
	)
)

if /i not "%SUBME%"=="step" (
	if %SUBME% GTR 9 (
		if not "%TRELLIS%"=="2" (
			set "MenueInput=f 2"
			call :READMENUEINPUT "[TRELLIS] AUTO-CORRECTION to [2]: SUBME greater 9 needs TRELLIS 2"
			goto :MAIN
		)
	)
)

if /i not "%SUBME%"=="step" (
	if %SUBME% GTR 9 (
		if not "%AQ-MODE%"=="1" (
			if not "%AQ-MODE%"=="2" (
				set "MenueInput=6 9"
				call :READMENUEINPUT "[SUBME] AUTO-CORRECTION to [9]: SUBME greater 9 needs AQ-MODE 1 or 2 and AQ-STRENGTH greater 0"
				goto :MAIN
			)
		)
	)
)

if /i not "%SUBME%"=="step" (
	if /i %SUBME% GTR 9 (
		if "%AQ-MODE%"=="1" (
			if not %AQ-STRENGTH% GTR 0 (
				set "MenueInput=i 1"
				call :READMENUEINPUT "[AQ-STRENGTH] AUTO-CORRECTION to [1]: SUBME greater 9 needs AQ-MODE 1 or 2 and AQ-STRENGTH greater 0"
				goto :MAIN
			)
		)
		if "%AQ-MODE%"=="2" (
			if not %AQ-STRENGTH% GTR 0 (
				set "MenueInput=i 1"
				call :READMENUEINPUT "[AQ-STRENGTH] AUTO-CORRECTION to [1]: SUBME greater 9 needs AQ-MODE 1 or 2 and AQ-STRENGTH greater 0"
				goto :MAIN
			)
		)
	)
)

if /i "%SUBME%"=="step" (
	if not %MAX_SUB% LEQ 9 (
		if not "%TRELLIS%"=="2" (
		set "MenueInput=f 2"
		call :READMENUEINPUT "[TRELLIS] AUTO-CORRECTION to [2]: MAX_SUB greater 9 needs TRELLIS 2"
		goto :MAIN
		)
	)
)
if /i "%SUBME%"=="step" (
	if not %MAX_SUB% LEQ 9 (
		if not "%AQ-MODE%"=="1" (
			if not "%AQ-MODE%"=="2" (
				set "MenueInput=h 2"
				call :READMENUEINPUT "[AQ-MODE] AUTO-CORRECTION to [2]: MAX_SUB greater 9 needs AQ-MODE 1 or 2 and AQ-STRENGTH greater 0"
				goto :MAIN
			)
		)
	)
)
if /i "%SUBME%"=="step" (
	if not %MAX_SUB% LEQ 9 (
		if "%AQ-MODE%"=="1" (
			if not %AQ-STRENGTH% GTR 0 (
				set "MenueInput=i 1"
				call :READMENUEINPUT "[AQ-STRENGTH] AUTO-CORRECTION to [1]: MAX_SUB greater 9 needs AQ-MODE 1 or 2 and AQ-STRENGTH greater 0"
				goto :MAIN
			)
		)
		if "%AQ-MODE%"=="2" (
			if not %AQ-STRENGTH% GTR 0 (
				set "MenueInput=i 1"
				call :READMENUEINPUT "[AQ-STRENGTH] AUTO-CORRECTION to [1]: MAX_SUB greater 9 needs AQ-MODE 1 or 2 and AQ-STRENGTH greater 0"
				goto :MAIN
			)
		)
	)
)

if not "%AQ-MODE%"=="0" (
	if /i "%ENCODINGMODE%"=="qp" (
		set "MenueInput=g crf"
		call :READMENUEINPUT "[ENCODINGMODE] AUTO-CORRECTION to [crf]: AQ-MODE greater 0 needs ENCODINGMODE CRF"
		goto :MAIN
	)
)
if not %AQ-STRENGTH% LEQ 0 (
	if /i "%ENCODINGMODE%"=="qp" (
		set "MenueInput=g crf"
		call :READMENUEINPUT "[ENCODINGMODE] AUTO-CORRECTION to [crf]: AQ-STRENGTH greater 0 needs ENCODINGMODE CRF"
		goto :MAIN
	)
)
if "%AQ-MODE%"=="0" (
	if not "%AQ-STRENGTH%"=="0" (
		set "MenueInput=i 0"
		call :READMENUEINPUT "[AQ-STRENGTH] AUTO-CORRECTION to [0]: AQ-MODE 0 needs AQ-STRENGTH 0 and reversly"
		goto :MAIN
	)
)
if "%AQ-STRENGTH%"=="0" (
	if not "%AQ-MODE%"=="0" (
		set "MenueInput=h 0"
		call :READMENUEINPUT "[AQ-MODE] AUTO-CORRECTION to [0]: AQ-STRENGTH 0 needs AQ-MODE 0 and reversly"
		goto :MAIN
	)
)


REM /* Check if user has deleted files while beeing in main menue
REM     or because x264 couldn't handle file before */
set "TempNumberOfFiles=0"
for /f "delims=" %%a in ('dir /b "%cd%\VIDEOFILES\*.*"') do (set /a TempNumberOfFiles=TempNumberOfFiles+1)
if %TempNumberOfFiles% NEQ %NumberOfFiles% goto :MAIN
if %TempNumberOfFiles%==0 goto :MAIN

REM // end of controlling all those user-input errors, do something :-)


if /i "%ME%"=="auto" (
	set "AutoME=1"
	set "AutoMERuns=0"
	set "ME=umh"
) else (
	set "AutoME=0"
)
if /i "%TRELLIS%"=="auto" (
	set "AutoTRELLIS=1"
	set "AutoTRELLISRuns=0"
	set "TRELLIS=0"
) else (
	set "AutoTRELLIS=0"
)
if /i "%MERANGE%"=="auto" (
	set "AutoMERANGE=1"
	set "AutoMERANGERuns=0"
	set "MERANGE=24"
) else (
	set "AutoMERANGE=0"
)


:LOOP
call :SHOWEFFECT 6
color 4c
cls
call :LOGO
for /f "tokens=1* delims==" %%a in ('wmic cpu list full') do (
	if "%%a"=="Name" set "CPUNAME=%%b"
	if "%%a"=="MaxClockSpeed" set "CPUCLOCK=%%b"
)
set CPUNAME=%CPUNAME%
set CPUCLOCK=%CPUCLOCK%
echo                                                      CPUNAME: %CPUNAME%
echo                                                      MAX. CPUCLOCK: %CPUCLOCK%
echo.
if "%time:~0,1%"==" " (set "StartTime=0%time:~1,-3%") else (set "StartTime=%time:~0,-3%")
set "StartTime=%date% %StartTime%"
echo                                                      Start time: %StartTime%
for /l %%a in (%MIN_PSYRD%,%STEP_PSYRD%,%MAX_PSYRD%) do (
	call :INTTOFLOAT "PSYRDFLOAT" "%%a"
	set "PSYRD=%%a"
	for /l %%a in (%MIN_PSYTR%,%STEP_PSYTR%,%MAX_PSYTR%) do (
		call :INTTOFLOAT "PSYTRFLOAT" "%%a"
		set "PSYTR=%%a"
		for /l %%a in (%MIN_QUANT%,%STEP_QUANT%,%MAX_QUANT%) do (
			set "QUANT=%%a"
			for /l %%a in (%MIN_SUB%,%STEP_SUB%,%MAX_SUB%) do (
				set "SUB=%%a"
				for /l %%a in (%MIN_REF%,%STEP_REF%,%MAX_REF%) do (
					set "REF=%%a"
					for /l %%a in (%MIN_BF%,%STEP_BF%,%MAX_BF%) do (
						REM // Inner Loop begins here (BFRAMES-LOOP)
						set "BF=%%a"
						call :RECOVER
						if not defined RecovRun (
							if not defined JobCounter (
								set JobCounter=1
							) else (
								set /a JobCounter=JobCounter+1
							)
							set "SumBitrate=0"
							set "SumSSIM=0"
							set "SumPSNR=0"
							set "SumBframeCount=0"
							set "SumFps=0"
				
							REM /* :AutoTRELLIS + :AutoME stay inactive if not def. OverAllCPULoad in first loop-run
							REM     if loop is called more than once :FINDLOOPEND has resetted OverallCPULoad before */
							call :SEL_AUTOTUNE_PARAMS
							set "OverallCPULoad="
							for /f "delims=" %%a in ('dir /b "%cd%\VIDEOFILES\*.*"') do (
								call :PAUSEME
								set "ActualFile=%%a"
								call :RUNX264 "%cd%\VIDEOFILES\%%a"
								call :PARSEOUTPUT
								setlocal enabledelayedexpansion
								if "!ParseError!"=="1" (endlocal & set "ParseError=" & goto :MAIN)
								endlocal
							)
							call :LOGOUTPUT
						)
					call :FINDLOOPEND "BF" "%%a" "%MIN_BF%" "%STEP_BF%" "%MAX_BF%"
					)
				call :FINDLOOPEND "REF" "%%a" "%MIN_REF%" "%STEP_REF%" "%MAX_REF%"
				)
			call :FINDLOOPEND "SUB" "%%a" "%MIN_SUB%" "%STEP_SUB%" "%MAX_SUB%"
			)
		call :FINDLOOPEND "QUANT" "%%a" "%MIN_QUANT%" "%STEP_QUANT%" "%MAX_QUANT%"
		)
	call :FINDLOOPEND "PSYTR" "%%a" "%MIN_PSYTR%" "%STEP_PSYTR%" "%MAX_PSYTR%"
	)
call :FINDLOOPEND "PSYRD" "%%a" "%MIN_PSYRD%" "%STEP_PSYRD%" "%MAX_PSYRD%"
)
REM End of the :MAIN FUNCTION, exiting
if exist "%cd%\system\recover.cfg" del /f /q "%cd%\system\recover.cfg"
COLOR 2A
call :SHOWEFFECT 5
cls
echo.
call :LOGO
echo.
echo                        ͻ
echo                        DONE! HIT A [KEY] TO SHOW STATISTIC FILEͼ
PAUSE>nul
start "" %STATISTICFILE%
COLOR 07
EXIT




REM ############################################################################
REM ################## END OF MAIN, BEGIN OF FUNCTIONS-BLOCK ###################




:INTTOFLOAT
REM // Modify PSYRD + PSYTR values generated in the loop to float-numbers for
REM    :RUNX264 + :LOGOUTPUT and some screen-messages
set "ModParam=%~1"
set "ModParamVal=%~2"
if "%ModParamVal%"=="0" set %ModParam%=0
if %ModParamVal% LSS 10 (if %ModParamVal% GTR 0 (set "%ModParam%=0.0%ModParamVal%"))
if %ModParamVal% LSS 100 (if %ModParamVal% GEQ 10 (set "%ModParam%=0.%ModParamVal%"))
if %ModParamVal% LSS 1000 (if %ModParamVal% GEQ 100 (set "%ModParam%=%ModParamVal:~0,1%.%ModParamVal:~1%"))
if %ModParamVal% GEQ 1000 (set "%ModParam%=%ModParamVal:~0,2%.%ModParamVal:~2%")
goto :EOF



:RECOVERMODE
color 0c
call :SHOWEFFECT 6
CLS
call :LOGO
echo                        RECOVER MODEͻ
echo                        BACKUP FOUND - CONTINUE LAST JOB^?ͼ
echo.
echo                        Recovery-file: ^"\System\recover.cfg^"
echo                        Used files in ^"VIDEOFILES^":
setlocal enabledelayedexpansion
for /f "usebackq delims== tokens=1*" %%a in ("%cd%\System\recover.cfg") do (if "%%a"=="VIDEOFILES" set "filelist=%%b")
for /l %%a in (1,1,31) do (call :LISTVIDS "LISTVIDS" "%%a")
:LISTVIDS
if "%~1"=="LISTVIDS" (
	for /f "delims=: tokens=%~2" %%a in ("!filelist!") do (echo                          %%a)
	goto :EOF
)
endlocal

echo                        X-QuaSaT interrupted at following parameters:
for /f "tokens=1* usebackq delims==" %%a in ("%cd%\System\recover.cfg") do (if not "%%a"=="VIDEOFILES" (echo                          %%a^=%%b))
echo.
echo     Do you want to load recovery-parameters and continue where script was interrupted or crashed last time^?
echo     ^(for safety reasons a new logfile will be created instead of continueing the old one^)
echo.
set /p "RecovAnswer=>[del]/[load]#"

if /i "%RecovAnswer%"=="del" (
	if exist "%cd%\system\recover.cfg" (del /f /q "%cd%\system\recover.cfg")
	if exist "%cd%\system\recover.bak" (del /f /q "%cd%\system\recover.bak")
	set "RecovRun="
	call :SHOWEFFECT 6 & cls
	goto :EOF
)
if /i not "%RecovAnswer%"=="load" (
	if /i not "%RecovAnswer%"=="del" (
		goto :RECOVERMODE
	)
)

REM // load backup parameters to memory if RecovAnswer "load"
for /f "usebackq tokens=1* delims==" %%a in ("%cd%\System\recover.cfg") do (set "%%a=%%b")
set "RecovRun=1"
call :STATFILENAME
call :SHOWEFFECT 6 & cls
goto :EOF



REM The STATFILENAME function is used for normal and recover-mode
:STATFILENAME
if /i "%OUTPUTFORMAT%"=="tab" (
	set STATFILENAME="STATISTIC.LOG"
	set STATISTICFILE="%cd%\STATISTIC.LOG"
	)
if /i "%OUTPUTFORMAT%"=="csv" (
	set STATFILENAME="STATISTIC.CSV"
	set STATISTICFILE="%cd%\STATISTIC.CSV"
)
:NEWNAME
if exist %STATISTICFILE% (
	if /i "%OUTPUTFORMAT%"=="tab" (
		set STATFILENAME="%STATFILENAME:~1,-5%_NEW.LOG"
		set STATISTICFILE="%STATISTICFILE:~1,-5%_NEW.LOG"
	)
	if /i "%OUTPUTFORMAT%"=="csv" (
	set STATFILENAME="%STATFILENAME:~1,-5%_NEW.CSV"
	set STATISTICFILE="%STATISTICFILE:~1,-5%_NEW.CSV"
	)
	if exist %STATISTICFILE% goto :NEWNAME
)
goto :EOF



:RECOVER
REM /* Block actions in the inner Loop of :MAIN until the saved parameters are reached
REM    (delete RecovRun if so. After that actions in loop will be done) */
if not defined RecoverCount (set RecoverCount=1)
if defined RecovRun (
	set /a RecoverCount=RecoverCount+1
	cls
	echo recovery in progress, skipping to [NR] %RecoverCount% of statistic file...
	if "%PSYRD%"=="%RecovPSYRD%" (
		if "%PSYTR%"=="%RecovPSYTR%" (
			if "%QUANT%"=="%RecovQUANT%" (
				if "%SUB%"=="%RecovSUB%" (
					if "%REF%"=="%RecovREF%" (
						if "%BF%"=="%RecovBF%" (
							set "RecovRun="
							set "RecoverCount="
							goto :EOF
						)
					)
				)
			)
		)
	)
	goto:EOF
)

REM /* If there's nothing to block anymore or recovery mode isn't used
REM    save recovery parameters after every inner loop */
REM // check if :RECOVER was interrupted because user closed script exactly while in action
echo New parameters for next job loaded, SAVING STATUS for crash recovery...
if exist "%cd%\system\recover.bak" (
	if exist "%cd%\system\recover.cfg" del /f /q "%cd%\system\recover.cfg"
	ren "%cd%\system\recover.bak" recover.cfg >nul
)
if exist "%cd%\system\recover.cfg" ren "%cd%\system\recover.cfg" recover.bak

setlocal enabledelayedexpansion
if "%time:~0,1%"==" " (set "BACKUPTIME=0%time:~1,-3%") else (set "BACKUPTIME=%time:~0,-3%")
echo BACKUPTIME=!date! !BACKUPTIME!>"%cd%\system\recover.cfg"
echo VIDEOFILES=!VIDEOFILES!>>"%cd%\system\recover.cfg"
echo STATFILENAME=!STATFILENAME!>>"%cd%\system\recover.cfg"

REM /* values that are generated in loop from input variables from settings.cfg
REM    save the actual values to know where to begin after recovering */
if defined SUB (echo RecovSUB=!SUB!>>"%cd%\system\recover.cfg")
if defined QUANT (echo RecovQUANT=!QUANT!>>"%cd%\system\recover.cfg")
if defined REF (echo RecovREF=!REF!>>"%cd%\system\recover.cfg")
if defined BF (echo RecovBF=!BF!>>"%cd%\system\recover.cfg")
if defined PSYRD (echo RecovPSYRD=!PSYRD!>>"%cd%\system\recover.cfg")
if defined PSYTR (echo RecovPSYTR=!PSYTR!>>"%cd%\system\recover.cfg")
if defined JobCounter (echo JobCounter=!JobCounter!>>"%cd%\system\recover.cfg")
if defined OverallJobs (echo OverallJobs=!OverallJobs!>>"%cd%\system\recover.cfg")

REM /* values delivered by settings.cfg */
if defined REFFRAMES (echo REFFRAMES=!REFFRAMES!>>"%cd%\system\recover.cfg")
if defined MIN_REF (echo MIN_REF=!MIN_REF!>>"%cd%\system\recover.cfg")
if defined STEP_REF (echo STEP_REF=!STEP_REF!>>"%cd%\system\recover.cfg")
if defined MAX_REF (echo MAX_REF=!MAX_REF!>>"%cd%\system\recover.cfg")
if defined BFRAMES (echo BFRAMES=!BFRAMES!>>"%cd%\system\recover.cfg")
if defined MIN_BF (echo MIN_BF=!MIN_BF!>>"%cd%\system\recover.cfg")
if defined STEP_BF (echo STEP_BF=!STEP_BF!>>"%cd%\system\recover.cfg")
if defined MAX_BF (echo MAX_BF=!MAX_BF!>>"%cd%\system\recover.cfg")
if defined QUANTIZATION (echo QUANTIZATION=!QUANTIZATION!>>"%cd%\system\recover.cfg")
if defined MIN_QUANT (echo MIN_QUANT=!MIN_QUANT!>>"%cd%\system\recover.cfg")
if defined STEP_QUANT (echo STEP_QUANT=!STEP_QUANT!>>"%cd%\system\recover.cfg")
if defined MAX_QUANT (echo MAX_QUANT=!MAX_QUANT!>>"%cd%\system\recover.cfg")
if defined SUBME (echo SUBME=!SUBME!>>"%cd%\system\recover.cfg")
if defined MIN_SUB (echo MIN_SUB=!MIN_SUB!>>"%cd%\system\recover.cfg")
if defined STEP_SUB (echo STEP_SUB=!STEP_SUB!>>"%cd%\system\recover.cfg")
if defined MAX_SUB (echo MAX_SUB=!MAX_SUB!>>"%cd%\system\recover.cfg")
if defined PSY-RD (echo PSY-RD=!PSY-RD!>>"%cd%\system\recover.cfg")
if defined MIN_PSYRD (echo MIN_PSYRD=!MIN_PSYRD!>>"%cd%\system\recover.cfg")
if defined STEP_PSYRD (echo STEP_PSYRD=!STEP_PSYRD!>>"%cd%\system\recover.cfg")
if defined MAX_PSYRD (echo MAX_PSYRD=!MAX_PSYRD!>>"%cd%\system\recover.cfg")
if defined MIN_PSYTR (echo MIN_PSYTR=!MIN_PSYTR!>>"%cd%\system\recover.cfg")
if defined STEP_PSYTR (echo STEP_PSYTR=!STEP_PSYTR!>>"%cd%\system\recover.cfg")
if defined MAX_PSYTR (echo MAX_PSYTR=!MAX_PSYTR!>>"%cd%\system\recover.cfg")

REM /* values can't be used like delivered from settings.cfg because they get modified by script */
if defined ME (echo ME=!ME!>>"%cd%\system\recover.cfg")
if defined MERANGE (echo MERANGE=!MERANGE!>>"%cd%\system\recover.cfg")
if defined TRELLIS (echo TRELLIS=!TRELLIS!>>"%cd%\system\recover.cfg")

REM /* values delivered by settings.cfg */
if defined ENCODINGMODE (echo ENCODINGMODE=!ENCODINGMODE!>>"%cd%\system\recover.cfg")
if defined AQ-MODE (echo AQ-MODE=!AQ-MODE!>>"%cd%\system\recover.cfg")
if defined AQ-STRENGTH (echo AQ-STRENGTH=!AQ-STRENGTH!>>"%cd%\system\recover.cfg")
if defined CPULOADTHRESHOLD (echo CPULOADTHRESHOLD=!CPULOADTHRESHOLD!>>"%cd%\system\recover.cfg")
if defined OUTPUTFORMAT (echo OUTPUTFORMAT=!OUTPUTFORMAT!>>"%cd%\system\recover.cfg")
if defined SAVETMPFILES (echo SAVETMPFILES=!SAVETMPFILES!>>"%cd%\system\recover.cfg")

REM /* needed values that are generated in running script */
if defined NumberOfFiles (echo NumberOfFiles=!NumberOfFiles!>>"%cd%\system\recover.cfg")
if defined OverAllCPULoad (echo OverAllCPULoad=!OverAllCPULoad!>>"%cd%\system\recover.cfg")
if defined AUTOME (echo AUTOME=!AUTOME!>>"%cd%\system\recover.cfg")
if defined AutoMERuns (echo AutoMERuns=!AutoMERuns!>>"%cd%\system\recover.cfg")
if defined AUTOMERANGE (echo AUTOMERANGE=!AUTOMERANGE!>>"%cd%\system\recover.cfg")
if defined AutoMERANGERuns (echo AutoMERANGERuns=!AutoMERANGERuns!>>"%cd%\system\recover.cfg")
if defined AUTOTRELLIS (echo AUTOTRELLIS=!AUTOTRELLIS!>>"%cd%\system\recover.cfg")
if defined AutoTRELLISRuns (echo AutoTRELLISRuns=!AutoTRELLISRuns!>>"%cd%\system\recover.cfg")
REM if defined CPUNAME (echo CPUNAME=!CPUNAME!>>"%cd%\system\recover.cfg")
REM if defined CPUCLOCK (echo CPUCLOCK=!CPUCLOCK!>>"%cd%\system\recover.cfg")

if exist "%cd%\system\recover.bak" (
	del /f /q "%cd%\system\recover.bak" >nul
)
endlocal
goto :EOF		



:READMENUEINPUT
REM /* Control MENUEINPUT for wrong inputs by user. If so return to :MAIN and
REM    re-read all old values from settings.cfg. Otherwise write settings.cfg new.
REM    Correct/generate interdepentend values like step-parameters
REM    and their main-parameters. Modify some int/float spellings with
REM    Subroutines :FLOATVAL + :CUTFOREGOINGZEROES */
set "MasterMessage="
set "MasterMessage=%~1"
REM // Read MenueInput and check for "reset"
if defined MenueInput (
	if /i "%MenueInput%"=="reset" (
		del /f /q "%cd%\system\settings.cfg"
		copy "%cd%\system\settings.bak" "%cd%\system\settings.cfg"
		endlocal & goto :EOF
	)
	REM // Read MenueInput an set matching variable to given value
	setlocal enabledelayedexpansion
	for /f "tokens=1*" %%a in ("%MenueInput%") do (
		if "%%a"=="0" set "REFFRAMES=%%b" & if not defined Message (set "Message=[REFFRAMES] saved^: [!REFFRAMES!]")
		if "%%a"=="1" set "REFLOOP=%%b" & if not defined Message (set "Message=[MIN_REF] [STEP_REF] [MAX_REF] saved^: [!REFLOOP!]")
		if "%%a"=="2" set "BFRAMES=%%b" & if not defined Message (set "Message=[BFRAMES] saved^: [!BFRAMES!]")
		if "%%a"=="3" set "BFLOOP=%%b" & if not defined Message (set "Message=[MIN_BF] [STEP_BF] [MAX_BF] saved^: [!BFLOOP!]")
		if "%%a"=="4" set "QUANTIZATION=%%b" & if not defined Message (set "Message=[QUANTIZATION] saved^: [!QUANTIZATION!]")
		if "%%a"=="5" set "QUANTLOOP=%%b" & if not defined Message (set "Message=[MIN_QUANT] [STEP_QUANT] [MAX_QUANT] saved^: [!QUANTLOOP!]")
		if "%%a"=="6" set "SUBME=%%b" & if not defined Message (set "Message=[SUBME] saved^: [!SUBME!]")
		if "%%a"=="7" set "SUBLOOP=%%b" & if not defined Message (set "Message=[MIN_SUB] [STEP_SUB] [MAX_SUB] saved^: [!SUBLOOP!]")
		if /i "%%a"=="a" set "PSY-RD=%%b" & if not defined Message (set "Message=[PSY-RD] saved^: [!PSY-RD!]")
		if /i "%%a"=="b" set "PSYRDLOOP=%%b" & if not defined Message (set "Message=[MIN_PSYRD] [STEP_PSYRD] [MAX_PSYRD] saved^: [!PSYRDLOOP!]")
		if /i "%%a"=="c" set "PSYTRLOOP=%%b" & if not defined Message (set "Message=[MIN_PSYTR] [STEP_PSYTR] [MAX_PSYTR] saved^: [!PSYTRLOOP!]")
		if /i "%%a"=="d" set "ME=%%b" & if not defined Message (set "Message=[ME] saved^: [!ME!]")
		if /i "%%a"=="e" set "MERANGE=%%b" & if not defined Message (set "Message=[MERANGE] saved^: [!MERANGE!]")
		if /i "%%a"=="f" set "TRELLIS=%%b" & if not defined Message (set "Message=[TRELLIS] saved^: [!TRELLIS!]")
		if /i "%%a"=="g" set "ENCODINGMODE=%%b" & if not defined Message (set "Message=[ENCODINGMODE] saved^: [!ENCODINGMODE!]")
		if /i "%%a"=="h" set "AQ-MODE=%%b" & if not defined Message (set "Message=[AQ-MODE] saved^: [!AQ-MODE!]")
		if /i "%%a"=="i" set "AQ-STRENGTH=%%b" & if not defined Message (set "Message=[AQ-STRENGTH] saved^: [!AQ-STRENGTH!]")
		if /i "%%a"=="j" set "CPULOADTHRESHOLD=%%b" & if not defined Message (set "Message=[CPULOADTHRESHOLD] saved^: [!CPULOADTHRESHOLD!]")
		if /i "%%a"=="k" set "OUTPUTFORMAT=%%b" & if not defined Message (set "Message=[OUTPUTFORMAT] saved^: [!OUTPUTFORMAT!]")
		if /i "%%a"=="l" set "SAVETMPFILES=%%b" & if not defined Message (set "Message=[SAVETMPFILES] saved^: [!SAVETMPFILES!]")
	)
	
	REM    
	
	if not "!ENCODINGMODE!"=="crf" (if not "!ENCODINGMODE!"=="qp" (endlocal & set "Message=wrong value" & goto :EOF))

	if /i not "!ME!"=="dia" (
		if /i not "!ME!"=="hex" (
			if /i not "!ME!"=="umh" (
				if /i not "!ME!"=="esa" (
					if /i not "!ME!"=="tesa" (
						if /i not "!ME!"=="auto" (
							endlocal & set "Message=wrong value" & goto :EOF
						)
					)
				)
			)
		)
	)


	if /i not "!MERANGE!"=="auto" (
		if not !MERANGE! LEQ 512 (endlocal & set "Message=wrong value" & goto :EOF)
		if not !MERANGE! GEQ 8 (endlocal & set "Message=wrong value" & goto :EOF)
		set /a MERANGE=MERANGE*1 & cls
	)
	
		
	REM // Read reference-frames settings and extract loop-parameters
	if /i "!REFFRAMES!"=="step" (
		for /f "tokens=1-3 delims= " %%a in ("!REFLOOP! ") do (
			if "%%a"=="" (endlocal & set "Message=[REFLOOP]: wrong value" & goto :EOF)
			if "%%b"=="" (endlocal & set "Message=[REFLOOP]: wrong value" & goto :EOF)
			if "%%c"=="" (endlocal & set "Message=[REFLOOP]: wrong value" & goto :EOF)
			set "MIN_REF=%%a" & set "STEP_REF=%%b" & set "MAX_REF=%%c"
		)
	) else (
		if not !REFFRAMES! LEQ 16 (endlocal & set "Message=wrong value" & goto :EOF)
		if not !REFFRAMES! GEQ 1 (endlocal & set "Message=wrong value" & goto :EOF)
		set /a REFFRAMES=REFFRAMES*1 & cls
		set "MIN_REF=!REFFRAMES!"
		set "STEP_REF=1"
		set "MAX_REF=!REFFRAMES!"
	)
	if not !MIN_REF! LEQ 16 (endlocal & set "Message=wrong value" & goto :EOF)
	if not !MIN_REF! GEQ 1 (endlocal & set "Message=wrong value" & goto :EOF)
	set /a MIN_REF=MIN_REF*1 & cls
	if not !STEP_REF! LEQ 16 (endlocal & set "Message=wrong value" & goto :EOF)
	if not !STEP_REF! GEQ 1 (endlocal & set "Message=wrong value" & goto :EOF)
	set /a STEP_REF=STEP_REF*1 & cls
	if not !MAX_REF! LEQ 16 (endlocal & set "Message=wrong value" & goto :EOF)
	if not !MAX_REF! GEQ 1 (endlocal & set "Message=wrong value" & goto :EOF)
	set /a MAX_REF=MAX_REF*1 & cls
	if !MAX_REF! LSS !MIN_REF! (endlocal & set "Message=[MAX_REF]: WRONG - MAX_REF less MIN_REF!" & goto :EOF)


	REM // Read B-frames settings and extract loop-parameters
	if /i "!BFRAMES!"=="step" (
		for /f "tokens=1-3 delims= " %%a in ("!BFLOOP! ") do (
			if "%%a"=="" (endlocal & set "Message=[BFLOOP]: wrong value" & goto :EOF)
			if "%%b"=="" (endlocal & set "Message=[BFLOOP]: wrong value" & goto :EOF)
			if "%%c"=="" (endlocal & set "Message=[BFLOOP]: wrong value" & goto :EOF)
			set "MIN_BF=%%a" & set "STEP_BF=%%b" & set "MAX_BF=%%c"
		)
	) else (
		if not !BFRAMES! LEQ 16 (endlocal & set "Message=wrong value" & goto :EOF)
		if not !BFRAMES! GEQ 1 (endlocal & set "Message=wrong value" & goto :EOF)
		set /a BFRAMES=BFRAMES*1 & cls
		set "MIN_BF=!BFRAMES!"
		set "STEP_BF=1"
		set "MAX_BF=!BFRAMES!"
	)
	if not !MIN_BF! LEQ 16 (endlocal & set "Message=wrong value" & goto :EOF)
	if not !MIN_BF! GEQ 1 (endlocal & set "Message=wrong value" & goto :EOF)
	set /a MIN_BF=MIN_BF*1 & cls
	if not !STEP_BF! LEQ 16 (endlocal & set "Message=wrong value" & goto :EOF)
	if not !STEP_BF! GEQ 1 (endlocal & set "Message=wrong value" & goto :EOF)
	set /a STEP_BF=STEP_BF*1 & cls
	if not !MAX_BF! LEQ 16 (endlocal & set "Message=wrong value" & goto :EOF)
	if not !MAX_BF! GEQ 1 (endlocal & set "Message=wrong value" & goto :EOF)
	set /a MAX_BF=MAX_BF*1 & cls
	if !MAX_BF! LSS !MIN_BF! (endlocal & set "Message=[MAX_BF]: WRONG - MAX_BF less MIN_BF!" & goto :EOF)


REM // Read subme settings and extract loop-parameters
	if /i "!SUBME!"=="step" (
		for /f "tokens=1-3 delims= " %%a in ("!SUBLOOP! ") do (
			if "%%a"=="" (endlocal & set "Message=[SUBLOOP]: wrong value" & goto :EOF)
			if "%%b"=="" (endlocal & set "Message=[SUBLOOP]: wrong value" & goto :EOF)
			if "%%c"=="" (endlocal & set "Message=[SUBLOOP]: wrong value" & goto :EOF)
			set "MIN_SUB=%%a" & set "STEP_SUB=%%b" & set "MAX_SUB=%%c"
		)
	) else (
		if not !SUBME! LEQ 11 (endlocal & set "Message=wrong value" & goto :EOF)
		if not !SUBME! GEQ 1 (endlocal & set "Message=wrong value" & goto :EOF)
		set /a SUBME=SUBME*1 & cls
		set "MIN_SUB=!SUBME!"
		set "STEP_SUB=1"
		set "MAX_SUB=!SUBME!"
	)

	if not !MIN_SUB! LEQ 11 (endlocal & set "Message=wrong value" & goto :EOF)
	if not !MIN_SUB! GEQ 1 (endlocal & set "Message=wrong value" & goto :EOF)
	set /a MIN_SUB=MIN_SUB*1 & cls
	if not !STEP_SUB! LEQ 10 (endlocal & set "Message=wrong value" & goto :EOF)
	if not !STEP_SUB! GEQ 1 (endlocal & set "Message=wrong value" & goto :EOF)
	set /a STEP_SUB=STEP_SUB*1 & cls
	if not !MAX_SUB! LEQ 11 (endlocal & set "Message=wrong value" & goto :EOF)
	if not !MAX_SUB! GEQ 6 (endlocal & set "Message=wrong value" & goto :EOF)
	set /a MAX_SUB=MAX_SUB*1 & cls
	if !MAX_SUB! LSS !MIN_SUB! (endlocal & set "Message=[MAX_SUB]: WRONG - MAX_SUB less MIN_SUB!" & goto :EOF)


REM /* Read QUANTIZATION settings and extract loop-parameters.
REM    Get QUANTIZATION value with help of :FLOATVAL-Function */
	if /i not "!QUANTIZATION!"=="step" (
		set "Val="
		set "Out="
		call :FLOATVAL "!QUANTIZATION!" "1" " " "69" "Val"
		if defined Val (set "QUANTIZATION=!Val!") else (endlocal & set "Message=[QUANTIZATION]: wrong value" & goto :EOF)
		if "!Encodingmode!"=="qp" (
			for /f "tokens=1-2 delims=." %%a in ("!QUANTIZATION!.") do (
				if not "%%b"=="" (
					set "Message=[QUANTIZATION] Auto-correction - decimal point only allowed in crf encoding mode"
					set /a QUANTIZATION=QUANTIZATION*1 & cls
				)
			)
		)
		if !QUANTIZATION! LSS 1 (endlocal & set "Message=wrong value" & goto :EOF)
	)

	if /i "!QUANTIZATION!"=="step" (
		for /f "tokens=1-3 delims= " %%a in ("!QUANTLOOP! ") do (
			if "%%a"=="" (endlocal & set "Message=[QUANTLOOP]: wrong value" & goto :EOF)
			if "%%b"=="" (endlocal & set "Message=[QUANTLOOP]: wrong value" & goto :EOF)
			if "%%c"=="" (endlocal & set "Message=[QUANTLOOP]: wrong value" & goto :EOF)
			set "MIN_QUANT=%%a" & set "STEP_QUANT=%%b" & set "MAX_QUANT=%%c"
		)
	) else (
		if not !QUANTIZATION! LEQ 69 (endlocal & set "Message=wrong value" & goto :EOF)
		if not !QUANTIZATION! GEQ 1 (endlocal & set "Message=wrong value" & goto :EOF)
		set /a QUANTIZATION=QUANTIZATION*1 & cls
		set "MIN_QUANT=!QUANTIZATION!"
		set "STEP_QUANT=1"
		set "MAX_QUANT=!QUANTIZATION!"
	)
	if not !MIN_QUANT! LEQ 69 (endlocal & set "Message=wrong value" & goto :EOF)
	if not !MIN_QUANT! GEQ 1 (endlocal & set "Message=wrong value" & goto :EOF)
	set /a MIN_QUANT=MIN_QUANT*1 & cls
	if not !STEP_QUANT! LEQ 68 (endlocal & set "Message=wrong value" & goto :EOF)
	if not !STEP_QUANT! GEQ 1 (endlocal & set "Message=wrong value" & goto :EOF)
	set /a STEP_QUANT=STEP_QUANT*1 & cls
	if not !MAX_QUANT! LEQ 69 (endlocal & set "Message=wrong value" & goto :EOF)
	if not !MAX_QUANT! GEQ 1 (endlocal & set "Message=wrong value" & goto :EOF)
	set /a MAX_QUANT=MAX_QUANT*1 & cls
	if !MAX_QUANT! LSS !MIN_QUANT! (endlocal & set "Message=[MAX_QUANT]: WRONG - MAX_QUANT less MIN_QUANT!" & goto :EOF)


	REM // TRELLIS
	if /i not "!TRELLIS!"=="auto" (
		if not !TRELLIS! LEQ 2 (endlocal & set "Message=wrong value" & goto :EOF)
		if not !TRELLIS! GEQ 0 (endlocal & set "Message=wrong value" & goto :EOF)
		set /a TRELLIS=TRELLIS*1 & cls
	)
	
	
	REM // AQ-MODE
	if not !AQ-MODE! LEQ 2 (endlocal & set "Message=wrong value" & goto :EOF)
	if not !AQ-MODE! GEQ 0 (endlocal & set "Message=wrong value" & goto :EOF)
	set /a AQ-MODE=AQ-MODE*1 & cls
	

	REM AQ-STRENGTH (handle 1 nr behind dec. point)
	for /f "delims=. tokens=1,2" %%a in ("!AQ-STRENGTH!") do (
		if not %%a GEQ 0 (endlocal & set "Message=wrong value" & goto :EOF)
		if not %%a LEQ 2 (endlocal & set "Message=wrong value" & goto :EOF)
		set "AQ-STRENGTHBefDec=%%a"
		set /a AQ-STRENGTHBefDec=AQ-STRENGTHBefDec*1 & cls
		set "AQ-STRENGTHAftDec=%%b"
		if defined AQ-STRENGTHAftDec (set "AQ-STRENGTHAftDec=!AQ-STRENGTHAftDec:~0,1!")
		set /a AQ-STRENGTHAftDec=AQ-STRENGTHAftDec*1 & cls
		REM // if only "0" after dec. point, ignore them!
		if "!AQ-STRENGTHAftDec!"=="0" (
			set "AQ-STRENGTHAftDec="
			set "AQ-STRENGTH=!AQ-STRENGTHBefDec!"
		)
		if defined AQ-STRENGTHAftDec (
			if "!AQ-STRENGTHBefDec!"=="2" (endlocal & set "Message=wrong value" & goto :EOF)
			if not !AQ-STRENGTHAftDec! LEQ 9 (endlocal & set "Message=wrong value" & goto :EOF)
			if not !AQ-STRENGTHAftDec! GEQ 1 (endlocal & set "Message=wrong value" & goto :EOF)
			set "AQ-STRENGTH=!AQ-STRENGTHBefDec!.!AQ-STRENGTHAftDec!"
		)
	)



	REM // If stepping not active, get PSYRD + PSYTR from PSY-RD	
	if /i not "!PSY-RD!"=="step" (
			
		REM // modify psy-rd values with help of :FLOATVAL-Function to standardized
		REM    numbers like 1.1 / 0.01 / 0.1 / 0 / 1
		set "Val=" & set "Out="
		call :FLOATVAL "!PSY-RD!" "1" ":" "10" "Val"
		if defined Val (set "Out=!Val!") else (endlocal & set "Message=[PSY-RD]: wrong value" & goto :EOF)
		call :FLOATVAL "!PSY-RD!" "2" ":" "10" "Val"
		if defined Val (set "PSY-RD=!Out!:!Val!") else (endlocal & set "Message=[PSY-RD]: wrong value" & goto :EOF)
		
		REM // Extract the standardized numbers PSYRD+PSYTR out of PSY-RD dataset
	 	for /f "delims=: tokens=1,2" %%a in ("!PSY-RD!") do (
		 set "PSYRD=%%a"
		 set "PSYTR=%%b"
 		)
		 	 	
		REM // Extract Value before and after dec. point from PSYRD, mod to integer
		for /f "delims=. tokens=1,2" %%a in ("!PSYRD!") do (
	 		set "PSYRDBefDec=%%a"
	 		set "PSYRDAftDec=%%b"
 		)
 		if "!PSYRDAftDec:~1,1!"=="" (
	 		if not "!PSYRDAftDec:~0,1!"=="0" (
				set "PSYRDAftDec=!PSYRDAftDec!0"
			)
		)
 		if "!PSYRDAftDec:~0,1!"=="0" (
			if not "!PSYRDAftDec:~1,0!"=="" (
				set "PSYRDAftDec=!PSYRDAftDec:~1!"
			)
		)
		if "!PSYRDAftDec!"=="" (
 			set "PSYRDAftDec=00"
		)
 		if not "!PSYRDBefDec!"=="0" (
	 		set "PSYRD=!PSYRDBefDec!!PSYRDAftDec!"
	 	) else (
	 		set "PSYRD=!PSYRDAftDec!"
 		)
 		
		set "MIN_PSYRD=!PSYRD!"
		set "STEP_PSYRD=1"
		set "MAX_PSYRD=!PSYRD!"
 		
		REM // Extract Value before and after dec. point from PSYTR, mod to integer
		for /f "delims=. tokens=1,2" %%a in ("!PSYTR!") do (
	 		set "PSYTRBefDec=%%a"
	 		set "PSYTRAftDec=%%b"
 		)
 		if "!PSYTRAftDec:~1,1!"=="" (
	 		if not "!PSYTRAftDec:~0,1!"=="0" (
				set "PSYTRAftDec=!PSYTRAftDec!0"
			)
		)
 		if "!PSYTRAftDec:~0,1!"=="0" (
			if not "!PSYTRAftDec:~1,0!"=="" (
				set "PSYTRAftDec=!PSYTRAftDec:~1!"
			)
		)
		if "!PSYTRAftDec!"=="" (
 			set "PSYTRAftDec=00"
		)
 		if not "!PSYTRBefDec!"=="0" (
	 		set "PSYTR=!PSYTRBefDec!!PSYTRAftDec!"
	 	) else (
	 		set "PSYTR=!PSYTRAftDec!"
 		)		
		set "MIN_PSYTR=!PSYTR!"
		set "STEP_PSYTR=1"
		set "MAX_PSYTR=!PSYTR!"
	)


	REM // If stepping active extract PSYRDLOOP parameters
	if /i "!PSY-RD!"=="step" (
		for /f "tokens=1-3 delims= " %%a in ("!PSYRDLOOP! ") do (
			if "%%a"=="" (endlocal & set "Message=[PSYRDLOOP]: wrong value" & goto :EOF)
			if "%%b"=="" (endlocal & set "Message=[PSYRDLOOP]: wrong value" & goto :EOF)
			if "%%c"=="" (endlocal & set "Message=[PSYRDLOOP]: wrong value" & goto :EOF)
			set "MIN_PSYRD=%%a" & set "STEP_PSYRD=%%b" & set "MAX_PSYRD=%%c"
		)
		call :CUTFOREGOINGZEROES "!MIN_PSYRD!" "MIN_PSYRD"
		call :CUTFOREGOINGZEROES "!STEP_PSYRD!" "STEP_PSYRD"
		call :CUTFOREGOINGZEROES "!MAX_PSYRD!" "MAX_PSYRD"
	)


	if not !MIN_PSYRD! LEQ 1000 (endlocal & set "Message=wrong value" & goto :EOF)
	if not !MIN_PSYRD! GEQ 0 (endlocal & set "Message=wrong value" & goto :EOF)
	set /a MIN_PSYRD=MIN_PSYRD*1 & cls
	if not !STEP_PSYRD! LEQ 999 (endlocal & set "Message=wrong value" & goto :EOF)
	if not !STEP_PSYRD! GEQ 1 (endlocal & set "Message=wrong value" & goto :EOF)
	set /a STEP_PSYRD=STEP_PSYRD*1 & cls
	if not !MAX_PSYRD! LEQ 1000 (endlocal & set "Message=wrong value" & goto :EOF)
	if not !MAX_PSYRD! GEQ 0 (endlocal & set "Message=wrong value" & goto :EOF)
	set /a MAX_PSYRD=MAX_PSYRD*1 & cls
	if !MAX_PSYRD! LSS !MIN_PSYRD! (endlocal & set "Message=[MAX_PSYRD]: WRONG - MAX_PSYRD less MIN_PSYRD!" & goto :EOF)


	REM // If stepping active extract PSYTRLOOP parameters
	if /i "!PSY-RD!"=="step" (
		for /f "tokens=1,2,3" %%a in ("!PSYTRLOOP!") do (
			if "%%a"=="" (endlocal & set "Message=[PSYTRLOOP]: wrong value" & goto :EOF)
			if "%%b"=="" (endlocal & set "Message=[PSYTRLOOP]: wrong value" & goto :EOF)
			if "%%c"=="" (endlocal & set "Message=[PSYTRLOOP]: wrong value" & goto :EOF)
			set "MIN_PSYTR=%%a" & set "STEP_PSYTR=%%b" & set "MAX_PSYTR=%%c"
		)
		call :CUTFOREGOINGZEROES "!MIN_PSYTR!" "MIN_PSYTR"
		call :CUTFOREGOINGZEROES "!STEP_PSYTR!" "STEP_PSYTR"
		call :CUTFOREGOINGZEROES "!MAX_PSYTR!" "MAX_PSYTR"
	)
	
	if not !MIN_PSYTR! LEQ 1000 (endlocal & set "Message=wrong value" & goto :EOF)
	if not !MIN_PSYTR! GEQ 0 (endlocal & set "Message=wrong value" & goto :EOF)
	set /a MIN_PSYTR=MIN_PSYTR*1 & cls
	if not !STEP_PSYTR! LEQ 999 (endlocal & set "Message=wrong value" & goto :EOF)
	if not !STEP_PSYTR! GEQ 1 (endlocal & set "Message=wrong value" & goto :EOF)
	set /a STEP_PSYTR=STEP_PSYTR*1 & cls
	if not !MAX_PSYTR! LEQ 1000 (endlocal & set "Message=wrong value" & goto :EOF)
	if not !MAX_PSYTR! GEQ 0 (endlocal & set "Message=wrong value" & goto :EOF)
	set /a MAX_PSYTR=MAX_PSYTR*1 & cls
	if !MAX_PSYTR! LSS !MIN_PSYTR! (endlocal & set "Message=[MAX_PSYTR]: WRONG - MAX_PSYTR less MIN_PSYTR!" & goto :EOF)


	if not !CPULOADTHRESHOLD! LEQ 10 (endlocal & set "Message=wrong value" & goto :EOF)
	if not !CPULOADTHRESHOLD! GEQ 1 (endlocal & set "Message=wrong value" & goto :EOF)
	set /a CPULOADTHRESHOLD=CPULOADTHRESHOLD*1 & cls
	
	
	if /i not "!OUTPUTFORMAT!"=="tab" (if /i not "!OUTPUTFORMAT!"=="csv" (endlocal & set "Message=wrong value" & goto :EOF))
	
	
	if /i not "!SAVETMPFILES!"=="off" (if /i not "!SAVETMPFILES!"=="on" (endlocal & set "Message=wrong value" & goto :EOF))
	
	REM // Write correct user-setted values to "config.cfg"
	echo REFFRAMES=!REFFRAMES!>"%cd%\system\settings.cfg"
	echo REFLOOP=!MIN_REF! !STEP_REF! !MAX_REF!>>"%cd%\system\settings.cfg"
	echo MIN_REF=!MIN_REF!>>"%cd%\system\settings.cfg"
	echo STEP_REF=!STEP_REF!>>"%cd%\system\settings.cfg"
	echo MAX_REF=!MAX_REF!>>"%cd%\system\settings.cfg"
	echo BFRAMES=!BFRAMES!>>"%cd%\system\settings.cfg"
	echo BFLOOP=!MIN_BF! !STEP_BF! !MAX_BF!>>"%cd%\system\settings.cfg"
	echo MIN_BF=!MIN_BF!>>"%cd%\system\settings.cfg"
	echo STEP_BF=!STEP_BF!>>"%cd%\system\settings.cfg"
	echo MAX_BF=!MAX_BF!>>"%cd%\system\settings.cfg"
	echo QUANTIZATION=!QUANTIZATION!>>"%cd%\system\settings.cfg"
	echo QUANTLOOP=!MIN_QUANT! !STEP_QUANT! !MAX_QUANT!>>"%cd%\system\settings.cfg"
	echo MIN_QUANT=!MIN_QUANT!>>"%cd%\system\settings.cfg"
	echo STEP_QUANT=!STEP_QUANT!>>"%cd%\system\settings.cfg"
	echo MAX_QUANT=!MAX_QUANT!>>"%cd%\system\settings.cfg"
	echo SUBME=!SUBME!>>"%cd%\system\settings.cfg"
	echo SUBLOOP=!MIN_SUB! !STEP_SUB! !MAX_SUB!>>"%cd%\system\settings.cfg"
	echo MIN_SUB=!MIN_SUB!>>"%cd%\system\settings.cfg"
	echo STEP_SUB=!STEP_SUB!>>"%cd%\system\settings.cfg"
	echo MAX_SUB=!MAX_SUB!>>"%cd%\system\settings.cfg"
	echo PSY-RD=!PSY-RD!>>"%cd%\system\settings.cfg"
	echo PSYRDLOOP=!MIN_PSYRD! !STEP_PSYRD! !MAX_PSYRD!>>"%cd%\system\settings.cfg"
	echo MIN_PSYRD=!MIN_PSYRD!>>"%cd%\system\settings.cfg"
	echo STEP_PSYRD=!STEP_PSYRD!>>"%cd%\system\settings.cfg"
	echo MAX_PSYRD=!MAX_PSYRD!>>"%cd%\system\settings.cfg"
	echo PSYTRLOOP=!MIN_PSYTR! !STEP_PSYTR! !MAX_PSYTR!>>"%cd%\system\settings.cfg"
	echo MIN_PSYTR=!MIN_PSYTR!>>"%cd%\system\settings.cfg"
	echo STEP_PSYTR=!STEP_PSYTR!>>"%cd%\system\settings.cfg"
	echo MAX_PSYTR=!MAX_PSYTR!>>"%cd%\system\settings.cfg"
	echo ME=!ME!>>"%cd%\system\settings.cfg"
	echo MERANGE=!MERANGE!>>"%cd%\system\settings.cfg"
	echo TRELLIS=!TRELLIS!>>"%cd%\system\settings.cfg"
	echo ENCODINGMODE=!ENCODINGMODE!>>"%cd%\system\settings.cfg"
	echo AQ-MODE=!AQ-MODE!>>"%cd%\system\settings.cfg"
	echo AQ-STRENGTH=!AQ-STRENGTH!>>"%cd%\system\settings.cfg"
	echo CPULOADTHRESHOLD=!CPULOADTHRESHOLD!>>"%cd%\system\settings.cfg"
	echo OUTPUTFORMAT=!OUTPUTFORMAT!>>"%cd%\system\settings.cfg"
	echo SAVETMPFILES=!SAVETMPFILES!>>"%cd%\system\settings.cfg"

	if not defined MasterMessage (
		for /f "delims=" %%a in ("!Message!") do (endlocal & set "Message=%%a")
	) else (
		for /f "delims=" %%a in ("!MasterMessage!") do (endlocal & set "Message=%%a")
	)
	cls
	goto :EOF
)


:CUTFOREGOINGZEROES
REM /* cut foregoing zeroes (onyl before dec. point at float values), if nothing left,
REM    set to "0". Set given variablename to value. */
set "Val=%~1"
set "VarName=%~2"
set "NoForeGoingZeroes="
	for /l %%a in (1,1,10) do (
		if not "!Val:~0,1!"=="0" set NoForeGoingZeroes=1
		if not "!NoForeGoingZeroes!"=="1" (
			set "Val=!Val:~1!"
		)
	)
if not defined Val (set "Val=0")
if "%Val:~0,1%"=="." (set "Val=0%Val%")
set "%VarName%=%Val%"
goto :EOF


:FLOATVAL
REM /* Extracts decimal values with 1 or 2 numbers behind dec. point out of variable 
REM    or dataset and gives back nothing if user/calling function delivered no numbers */
set "FloatValVar=%~1"
set "FloatValToken=%~2"
set "FloatValDelims=%~3"
set "FloatValMax=%~4"
set "FloatValOut=%~5"
set "FloatBefDec="
set "!FloatValOut!="
set "FloatAftDec="
set "Floatzero="
REM /* "" Dataset is added to the end of dataset-variable, so :FLOATVAL can detect
REM     if one or more values are missing in given dataset.
REM     If so the last dataset is "" -> empty (no) value will be returned */
set "FloatValVar=%FloatValVar%%FloatValDelims%"
REM //If variable with more than one dataset is given extract correct token
for /f "tokens=%FloatValToken% delims=%FloatValDelims%" %%a in ("%FloatValVar%") do (
	if "%%a"=="" set "!FloatValOut!=" & goto :EOF
	set "FloatValue=%%a"
	)
for /f "delims=. tokens=1,2" %%a in ("!FloatValue!") do (
	if not "%%a" GEQ "0" (goto :EOF)
	set "FloatBefDec=%%a"
	if not defined FloatBefDec (goto :EOF)
	
	REM // cut foregoing zeroes before dec. point, if nothing left, set to "0"
	set "ForeGoingZeroes="
	for /l %%a in (1,1,10) do (
		if not "!FloatBefDec:~0,1!"=="0" set ForeGoingZeroes=1
		if not "!ForeGoingZeroes!"=="1" (
			set "FloatBefDec=!FloatBefDec:~1!"
		)
	)
	if not defined FloatBefDec (set "FloatBefDec=0")
	
	set /a FloatBefDec=FloatBefDec*1 & cls
	if not !FloatBefDec! GEQ 0 (goto :EOF)

	if !FloatBefDec! GTR !FloatValMax! (goto :EOF)

	set "FloatAftDec=%%b"
	if defined FloatAftDec (set "FloatAftDec=!FloatAftDec:~0,2!")
	REM if "!FloatAftDec:~1,1!"=="0" (set "FloatAftDec=!FloatAftDec:~0,1!")
	REM // if number begins with "0" after decimal point, remove and remember in "Floatzero"
	if "!FloatAftDec:~0,1!"=="0" (set "FloatAftDec=!FloatAftDec:~1!" & set Floatzero=1)
	
	set /a FloatAftDec=FloatAftDec*1 & cls
	REM // if only "0" after dec. point, ignore them!
	if "!FloatAftDec!"=="0" (
		set "FloatAftDec="
		set "!FloatValOut!=!FloatBefDec!"
	)

	REM // special case before dec. point is extactly FloatValMax
	if defined FloatAftDec (
		if "!FloatBefDec!"=="!FloatValMax!" (
			if not "!FloatAftDec!" == "0" (
				if not "!FloatAftDec!" == "00" (
					goto :EOF
				)
			)
		)
	)
			
	REM /* if earlier after decimal point had been detected a "0", add it now,
	REM    otherwise merge FloatValBefDec+FloatValAftDec */
	if not defined !FloatValOut! (
		if "!Floatzero!"=="1" (
			set "!FloatValOut!=!FloatBefDec!.0!FloatAftDec!"
		) else (
			set "!FloatValOut!=!FloatBefDec!.!FloatAftDec!"
		)
	)
)
goto :EOF



REM /* Resets AutoTrellis+AutoME+AutoMERANGE in every new Loop */
:FINDLOOPEND
set "LoopType=%~1"
set "Loop=%~2"
set "MinLoop=%~3"
set "StepLoop=%~4"
set "MaxLoop=%~5"
if not defined LoopType goto :EOF
if not defined Loop goto :EOF
if not defined MinLoop goto :EOF
if not defined StepLoop gooto :EOF
if not defined MaxLoop goto :EOF

REM set "CurrLoopName="
REM if not defined %LoopType%-Loop set "CurrLoopName=%LoopType%-Loop"
set /a LoopPercentage = (JobCounter*100)/OverallJobs
echo                        ͻ
echo                                                    Started at %StartTime% - %JobCounter% of %OverallJobs% jobs done ^(%LoopPercentage%^%%^)!!!
echo.
set /a LoopEnd=Loop+StepLoop
if %LoopEnd% GTR %MaxLoop% (
	set "OverAllCPULoad="
	echo                         End of %LoopType%-Loop reached ^(Stepped to %LoopEnd%/%MaxLoop%^), restarting at %MinLoop%...
	if "%AutoME%"=="1" (
		echo                         Resetting AutoME...
		set "AutoMERuns=0"
		set "ME=umh"
	)
	if "%AutoMERANGE%"=="1" (
		echo                         Resetting AutoMERANGE...
		set "AutoMERANGERuns=0"
		set "MERANGE=24"
	)
	if "%AutoTRELLIS%"=="1" (
		echo                         Resetting AutoTRELLIS...
		set "AutoTRELLISRuns=0"
		set "TRELLIS=0"
	)
)
echo                        ͼ
goto :EOF



:SEL_AUTOTUNE_PARAMS
if not %BF% GTR %REF% goto :EOF
if not defined OverAllCPULoad goto :EOF
REM /* If user selects Auto-tune function on:
REM    TRELLIS depends on that AutoME and AUTOMERANGE are activated first,
REM    AUTOMERANGE depends on AUTOME
REM    AUTOME runs always */

REM // only one autotune-function active
if not "%AUTOMERANGE%"=="1" (
	if not "%AUTOTRELLIS%"=="1" (
		if "%AUTOME%"=="1" (
			call :AUTOTUNE "%AutoMERuns%" "ME" "umh" "esa" "75;87;92;94" "blank;1" "blank;1" "blank;1" "blank;1"
		)
	)
)
if not "%AUTOME%"=="1" (
	if not "%AUTOTRELLIS%"=="1" (
		if "%AUTOMERANGE%"=="1" (
			call :AUTOTUNE "%AutoMERANGERuns%" "MERANGE" "24" "32" "75;87;92;94" "blank;1" "blank;1" "blank;1" "blank;1"
		)
	)
)
if not "%AUTOME%"=="1" (
	if not "%AUTOMERANGE%"=="1" (
		if "%AUTOTRELLIS%"=="1" (
			call :AUTOTUNE "%AutoTRELLISRuns%" "TRELLIS" "0" "2" "75;87;92;94" "blank;1" "blank;1" "blank;1" "blank;1"
		)
	)
)

REM // two autotune-functions active
if "%AUTOME%"=="1" (
	if "%AUTOMERANGE%"=="1" (
		if not "%AUTOTRELLIS%"=="1" (
			call :AUTOTUNE "AutoMERANGERuns;%AutoMERANGERuns%" "MERANGE" "24" "32" "75;87;92;94" "AutoMERuns;%AutoMERuns%" "blank;1" "blank;1" "blank;1"
			call :AUTOTUNE "AutoMERuns;%AutoMERuns%" "ME" "umh" "esa" "75;87;92;94" "blank;1" "blank;1" "blank;1" "blank;1"
		)
	)
)
if "%AUTOME%"=="1" (
	if "%AUTOTRELLIS%"=="1" (
		if not "%AUTOMERANGE%"=="1" (
			call :AUTOTUNE "AutoTRELLISRuns;%AutoTRELLISRuns%" "TRELLIS" "0" "2" "75;87;92;94" "AutoMERuns;%AutoMERuns%" "blank;1" "blank;1" "blank;1"
			call :AUTOTUNE "AutoMERuns;%AutoMERuns%" "ME" "umh" "esa" "75;87;92;94" "blank;1" "blank;1" "blank;1" "blank;1"
		)
	)
)
if "%AUTOMERANGE%"=="1" (
	if "%AUTOTRELLIS%"=="1" (
		if not "%AUTOME%"=="1" (
			call :AUTOTUNE "AutoTRELLISRuns;%AutoTRELLISRuns%" "TRELLIS" "0" "2" "75;87;92;94" "AutoMERANGERuns;%AutoMERANGERuns%" "blank;1%" "blank;1" "blank;1"
			call :AUTOTUNE "AutoMERANGERuns;%AutoMERANGERuns%" "MERANGE" "24" "32" "75;87;92;94" "blank;1" "blank;1" "blank;1" "blank;1"
		)
	)
)

REM // all autotune-functions active
if "%AUTOME%"=="1" (
	if "%AUTOMERANGE%"=="1" (
		if "%AUTOTRELLIS%"=="1" (
			call :AUTOTUNE "AutoTRELLISRuns;%AutoTRELLISRuns%" "TRELLIS" "0" "2" "75;87;92;94" "AutoMERuns;%AutoMERuns%" "AutoMERANGERuns;%AutoMERANGERuns%" "blank;1" "blank;1"
			call :AUTOTUNE "AutoMERANGERuns;%AutoMERANGERuns%" "MERANGE" "24" "32" "75;87;92;94" "AutoMERuns;%AutoMERuns%" "blank;1" "blank;1" "blank;1"
			call :AUTOTUNE "AutoMERuns;%AutoMERuns%" "ME" "umh" "esa" "75;87;92;94" "blank;1" "blank;1" "blank;1" "blank;1"
		)
	)
)
goto :EOF




:AUTOTUNE
if not %BF% GTR %REF% goto :EOF
if not defined OverAllCPULoad goto :EOF
REM set "blank=1"
set "FunctRuns=%~1"
set "FunctParamName=%~2"
set "FunctParamInit=%~3"
set "FunctParamAct=%~4"
set "FunctCPUThreshs=%~5"
set "FunctDep1=%~6"
set "FunctDep2=%~7"
set "FunctDep3=%~8"
set "FunctDep4=%~9"
for /f "delims=; tokens=1-2" %%a in ("%FunctRuns%") do (
	set "FunctRunsName=%%a"
	set "FunctRunsVal=%%b"
)
REM // Check if auto-functions (FunctDep1-4) which current auto-function depends on, are active - if not goto :EOF
REM // FunctDep1-4 include "AutoFunctionsRunParameterName;AutoFunctionsRunParameterValue"
setlocal enabledelayedexpansion
for /l %%a in (1,1,4) do (
	for /f "delims=; tokens=1-2" %%a in ("!FunctDep%%a!") do (
		if not "%%b"=="1" (endlocal & goto :EOF)
	)
 )
endlocal

if %STEP_BF%==1 (
	for /f "delims=; tokens=1" %%a in ("%FunctCPUThreshs%") do (set CPUThresh=%%a)
)
if %STEP_BF%==2 (
	for /f "delims=; tokens=2" %%a in ("%FunctCPUThreshs%") do (set CPUThresh=%%a)
)
if %STEP_BF%==3 (
	for /f "delims=; tokens=3" %%a in ("%FunctCPUThreshs%") do (set CPUThresh=%%a)
)
if %STEP_BF% GEQ 4 (
	for /f "delims=; tokens=4" %%a in ("%FunctCPUThreshs%") do (set CPUThresh=%%a)
)

if %OverallCPULoad% LEQ %CPUThresh% (
	set "%FunctParamName%=%FunctParamAct%"
	set "%FunctRunsName%=1"
) else (
	if not "%FunctRunsVal%"=="1" (
		set "%FunctParamName%=%FunctParamInit%"
	)
)
goto :EOF
		


REM FUNCTION: Wait until external CPU-Load measurement process terminates
:WAITFORMEASURE
if "%~1"=="WAITFORMEASURE" (
	if exist "%cd%\tmp\CpuMeasureDone.tmp" (
			goto :EOF
	) else (goto :WAITFORMEASURE)
)



:PAUSEME
set "PausMeQuest="
if exist "%cd%\tmp\pauseme.tmp" (
	color 87
	call :LOGO
	echo.
	echo                        You activated ^"^(Un^)PauseMe.cmd^" BEFORE!ͻ
	echo                        Hit [RETURN] to continue or type SAVE to recover job later and exitͼ
	setlocal enabledelayedexpansion
	set /P "PausMeQuest=>[]/[save]#"
	if /i "!PausMeQuest!"=="save" (
		call :RECOVER
		if exist "%cd%\tmp\pauseme.tmp" (del /f /q "%cd%\tmp\pauseme.tmp")
		endlocal & EXIT
	)
	if /i not "!PausMeQuest!"=="" (
		cls
		endlocal & goto :PAUSEME
	)
)

if exist "%cd%\tmp\pauseme.tmp" (del /f /q "%cd%\tmp\pauseme.tmp")
COLOR 4C
goto :EOF




REM FUNCTION: Control Current CPULOAD if it's higher than threshold in "settings.cfg"
:LOADTOHIGH
if "%~1"=="LOADTOHIGH" (
	setlocal enabledelayedexpansion
	set "CurrCPULoad="
	echo Measuring current idle CPU-Load if it's not higher than !CPULOADTHRESHOLD!^%%...
	for /f "tokens=1,2 delims==" %%a IN ('"WMIC CPU GET LoadPercentage /VALUE"') DO (
		if /i "%%a"=="LoadPercentage" (set "CurrCPULoad=%%b")
	)
	if not defined CurrCPULoad (
		echo Could not measure CPU-Load, trying again...
		endlocal
		goto :LOADTOHIGH
	)
	REM Remove Line Break Bug that "WMIC CPU GET LoadPercentage" adds to "CurrCPULoad"-Variable...
	set /a CurrCPULoad=CurrCPULoad*1
	echo Current idle CPULoad is !CurrCPULoad!%%...
	if !CurrCPULoad! GTR !CPULOADTHRESHOLD! (
		call :LOGO
		echo.
		echo Current CPU Load of !CurrCPULoad!%% is to high. Threshold is !CPULOADTHRESHOLD!%%
		echo ^(Threshold Configurable in ^"System\SETTINGS.CFG^"^)
		echo.
		endlocal
		goto :LOADTOHIGH
	)
	endlocal
	goto :EOF
)



REM // Start x264 encoding process & measure CPU Load while doing that
:RUNX264
call :LOGO "pausetxt"
set INFILE=%1%
if /i "%SAVETMPFILES%"=="on" (
	set OUTFILE="%cd%\tmp\%JobCounter%_%ActualFile%.mkv"
)
if exist %outfile% del /f /q %outfile%
if exist "%windir%\SysWOW64" (set "X264Ver=x264_x64.exe") else (set "X264Ver=x264_x32.exe")
REM // Control if CPU is under load before the real statistically measurement is started
call :LOADTOHIGH "LOADTOHIGH"
REM // start external CPU-Load measurement process to get CPU-Load while encoding is running
if exist "%cd%\tmp\TermCPUMeasure.tmp" del /f /q "%cd%\tmp\TermCPUMeasure.tmp"
if defined LoopPercentage (
	start "%LoopPercentage%%% (Job %JobCounter% of %OverallJobs% running...) - measuring CPU-load...                                                                      " /min "%cd%\system\cpuload.cmd"
) else (
	start "0%% of jobs done... - measuring CPU-load...                                                                                                                 " /min "%cd%\system\cpuload.cmd"
)

echo Start X264 analysis for file with settings listed below:
echo   %INFILE%
echo   REF:%REF% BFRAMES:%BF% QUANTIZATION:%QUANT% ME:%ME% MERANGE:%MERANGE% SUBME:%SUB% ENCODINGMODE:%ENCODINGMODE%
echo   TRELLIS:%TRELLIS% AQ-MODE:%AQ-MODE% AQ-STRENGTH:%AQ-STRENGTH% PSY-RD:%PSYRDFLOAT%:%PSYTRFLOAT%
echo.

echo %X264Ver% --%ENCODINGMODE% %QUANT% --ref %REF% --keyint 500 --min-keyint 0 --scenecut 40 --bframes %BF% --b-bias 0 --b-pyramid normal --direct auto --b-adapt 2 --sync-lookahead 25 --partitions all --8x8dct --no-fast-pskip --me %ME% --merange %MERANGE% --mvrange -1 --subme %SUB% --cabac --trellis %TRELLIS% --psy-rd %PSYRDFLOAT%:%PSYTRFLOAT% --weightp 2 --aq-mode %AQ-MODE% --aq-strength %AQ-STRENGTH% --nr 0 --deadzone-inter 21 --deadzone-intra 11 --cqm flat --threads auto --sar 1:1 --deblock -1:-1 --psnr --ssim --colormatrix undef --output %OUTFILE% %INFILE%
echo %X264Ver% --%ENCODINGMODE% %QUANT% --ref %REF% --keyint 500 --min-keyint 0 --scenecut 40 --bframes %BF% --b-bias 0 --b-pyramid normal --direct auto --b-adapt 2 --sync-lookahead 25 --partitions all --8x8dct --no-fast-pskip --me %ME% --merange %MERANGE% --mvrange -1 --subme %SUB% --cabac --trellis %TRELLIS% --psy-rd %PSYRDFLOAT%:%PSYTRFLOAT% --weightp 2 --aq-mode %AQ-MODE% --aq-strength %AQ-STRENGTH% --nr 0 --deadzone-inter 21 --deadzone-intra 11 --cqm flat --threads auto --sar 1:1 --deblock -1:-1 --psnr --ssim --colormatrix undef --output %OUTFILE% %INFILE% > %LOGFILE%
echo. >>%LOGFILE%
%X264Ver% --%ENCODINGMODE% %QUANT% --ref %REF% --keyint 500 --min-keyint 0 --scenecut 40 --bframes %BF% --b-bias 0 --b-pyramid normal --direct auto --b-adapt 2 --sync-lookahead 25 --partitions all --8x8dct --no-fast-pskip --me %ME% --merange %MERANGE% --mvrange -1 --subme %SUB% --cabac --trellis %TRELLIS% --psy-rd %PSYRDFLOAT%:%PSYTRFLOAT% --weightp 2 --aq-mode %AQ-MODE% --aq-strength %AQ-STRENGTH% --nr 0 --deadzone-inter 21 --deadzone-intra 11 --cqm flat --threads auto --sar 1:1 --deblock -1:-1 --psnr --ssim --colormatrix undef --output %OUTFILE% %INFILE% >> %LOGFILE% 2>&1


REM // Terminate external CPU-Load measurement process
echo.>"%cd%\tmp\TermCPUMeasure.tmp"
echo Waiting for CPU-Load measurement...
call :WAITFORMEASURE "WAITFORMEASURE"
REM // Read results of external CPU-Load measurement process
setlocal enabledelayedexpansion
for /f "usebackq delims=" %%a in ("%cd%\tmp\CPULoad.log") do (
	set FilesCPULoad=%%a
	if defined OverallCPULoad (
		set /a OverallCPULoad=OverallCPULoad+FilesCPULoad
	)	else (set "OverallCPULoad=%%a")
)
for /f "delims=$ tokens=1,2" %%a in ("!OverallCPULoad!$!FilesCPULoad!") do (endlocal & set "OverallCPULoad=%%a" & set "FilesCPULoad=%%b")
if exist "%cd%\tmp\CPULoad.log" del /f /q "%cd%\tmp\CPULoad.log"
goto :EOF



REM // Analyse X264 Outputs for statistic values or errors
:PARSEOUTPUT
call :LOGO "pausetext"
set "ParseError="
set "x264ErrMess="
if not exist "%cd%\%X264Ver%" set "x264ErrMess=error"
if not exist %LOGFILE% set "x264ErrMess=error"
for /f "skip=2 delims=" %%a in ('find "[error]" %LOGFILE%') do (
	echo %%a
	set "x264ErrMess=%%a"
)
for /f "skip=2 delims=" %%a in ('find "x264 [warning]: too many nonmonotonic pts warnings, suppressing further ones" %LOGFILE%') do (
	echo %%a
	set "x264ErrMess=%%a"
)
if defined x264ErrMess (
	COLOR 87
	echo.
	echo Waiting for CPU-Load measurement proccess to terminate...
	call :WAITFORMEASURE "WAITFORMEASURE"
	echo.
	if exist "%cd%\%X264Ver%" (
		echo ERROR - X264 could not handle file:
		echo %INFILE%
	) else (
		echo ERROR - %X264Ver% not found!
	)
	echo.
	echo                         X264 ERRORͻ
	echo                         Type SAVE to recover job later and exit, type EXIT to exitͼ
	echo.
	setlocal enabledelayedexpansion
	set /P "ParseError=>[save]/[exit]#"
	if /i "!ParseError!"=="save" (endlocal & call :RECOVER & EXIT)
	if /i "!ParseError!"=="exit" (endlocal & EXIT)
	if /i not "!ParseError!"=="save" (
		if /i not "!ParseError!"=="exit" (
 			endlocal & cls & goto :PARSEOUTPUT
		)
	)
)


setlocal enabledelayedexpansion
for /f "skip=2 tokens=6" %%a in ('find "x264 [info]: SSIM Mean Y:" %LOGFILE%') do (
	set "SSIM=%%a"
	set "SSIM=!SSIM:~1,-3!"
)
for /f "skip=2 tokens=1-8" %%a in ('find "x264 [info]: PSNR Mean Y:" %LOGFILE%') do (
	set "AvgPSNR=%%h"
	set "AvgPSNR=!AvgPSNR:~4!"
)
for /f "skip=2 tokens=4" %%a in ('find "x264 [info]: frame B:" %LOGFILE%') do (
	set "BframeCount=%%a"
	set "BframeCount=!BframeCount:~2!"
)
for /f "skip=2 tokens=4" %%a in ('find "x264 [info]: frame P:" %LOGFILE%') do (
	set "PframeCount=%%a"
	set "PframeCount=!PframeCount:~2!"
)
for /f "skip=2 tokens=4" %%a in ('find "x264 [info]: frame I:" %LOGFILE%') do (
	set "IframeCount=%%a"
	set "IframeCount=!IframeCount:~2!"
)

for /f "skip=2 tokens=1-8" %%a in ('find "encoded " %LOGFILE%') do (
	set "fps=%%d"
	set "bitrate=%%f"
)
for /f "delims=$ tokens=1-7" %%a in ("!SSIM!$!BframeCount!$!PframeCount!$!IframeCount!$!fps!$!bitrate!$!AvgPSNR!") do (endlocal & set "SSIM=%%a" & set "BframeCount=%%b" & set "PframeCount=%%c" & set "IframeCount=%%d" & set "fps=%%e" & set "bitrate=%%f" & set "AvgPSNR=%%g")
echo X264'S RESULTS AND CPULOAD:
echo AvgPSNR:%AvgPSNR% SSIM:%SSIM% FPS:%fps% BR:%bitrate% BF_USED:%BframeCount% PF_USED:%PframeCount% IF_USED:%IframeCount% FilesCPULoad:%FilesCPULoad%
echo.

REM // remove decimal point to calculate with more precision @ :LOGOUTPUT (*1000)
for /f "delims=. tokens=1,2" %%a in ("%SSIM%") do (set "SSIM=%%a%%b")
REM // remove decimal point to calculate with more precision @ :LOGOUTPUT (*100)
for /f "delims=. tokens=1,2" %%a in ("%fps%") do (set "fps=%%a%%b")
REM // remove decimal point to calculate with more precision @ :LOGOUTPUT (*100)
for /f "delims=. tokens=1,2" %%a in ("%bitrate%") do (set "bitrate=%%a%%b")
REM // remove decimal point to calculate with more precision @ :LOGOUTPUT (*1000)
for /f "delims=. tokens=1,2" %%a in ("%AvgPSNR%") do (set "AvgPSNR=%%a%%b")

REM // summarizing analysation results of files with identical parameters
set /a SumSSIM=SumSSIM+SSIM
set /a SumFps=SumFps+fps
set /a SumBitrate=SumBitrate+bitrate
set /a SumPSNR=SumPSNR+AvgPSNR
set /a SumBframeCount=SumBframeCount+BframeCount
set /a SumPframeCount=SumPframeCount+PframeCount
set /a SumIframeCount=SumIframeCount+IframeCount

echo Building the average results for job %JobCounter% out of x264 analysation results
echo from all files in ^"VIDEOFILES^" analysed with current parameters...
goto :EOF



:LOGOUTPUT
REM /* Cut results depending on desired decimal place precision,
REM    round rest (+1 depending on result).
REM    IMPORTANT: Input values got multiplied before because of removed dec. pont! */

set "LOGOUTPUT_ERR="
set "round=0"
set /a SumSSIM=((SumSSIM*1000)/NumberOfFiles)
set round=%SumSSIM:~-3%
set SumSSIM=%SumSSIM:~0,-3%
if %round% GEQ 500 set /a SumSSIM=SumSSIM+1
set "FormatedSumSSIM=%SumSSIM:~0,-3%.%SumSSIM:~-3%"

set "round=0"
set /a SumPSNR=((SumPSNR*1000)/NumberOfFiles)
set round=%SumPSNR:~-3%
set SumPSNR=%SumPSNR:~0,-3%
if %round% GEQ 500 set /a SumPSNR=SumPSNR+1
set "FormatedSumPSNR=%SumPSNR:~0,-3%.%SumPSNR:~-3%"

set "round=0"
set /a SumFps=((SumFps*1000)/NumberOfFiles)
set round=%SumFps:~-4%
set SumFps=%SumFps:~0,-4%
if %round% GEQ 5000 set /a SumFps=SumFps+1
set "FormatedSumFps=%SumFps:~0,-1%.%SumFps:~-1%"

set "round=0"
set /a SumBframeCount=((SumBframeCount*1000)/NumberOfFiles)
set round=%SumBframeCount:~-3%
set SumBframeCount=%SumBframeCount:~0,-3%
if %round% GEQ 500 set /a SumBframeCount=SumBframeCount+1

set "round=0"
set /a SumPframeCount=((SumPframeCount*1000)/NumberOfFiles)
set round=%SumPframeCount:~-3%
set SumPframeCount=%SumPframeCount:~0,-3%
if %round% GEQ 500 set /a SumPframeCount=SumPframeCount+1

set "round=0"
set /a SumIframeCount=((SumIframeCount*1000)/NumberOfFiles)
set round=%SumIframeCount:~-3%
set SumIframeCount=%SumIframeCount:~0,-3%
if %round% GEQ 500 set /a SumIframeCount=SumIframeCount+1

set "round=0"
set /a SumBitrate=SumBitrate/NumberOfFiles
set round=%SumBitrate:~-2%
set SumBitrate=%SumBitrate:~0,-2%
if %round% GEQ 50 set /a SumBitrate=SumBitrate+1

set /a OverallCPULoad=OverallCPULoad/NumberOfFiles

call :LOGO
echo                        ͻ
echo                         WRITING THOSE AVERAGE VALUES FOR THE LISTED SETTINGS TO STATISTIC-FILE:
echo.
echo                         REF:%REF% BFRAMES:%BF% QUANTIZATION:%QUANT% ME:%ME% MERANGE:%MERANGE% SUBME:%SUB% TRELLIS:%TRELLIS%
echo                         ENCODINGMODE:%ENCODINGMODE% AQ-MODE:%AQ-MODE% AQ-STRENGTH:%AQ-STRENGTH% PSY-RD:%PSYRDFLOAT%:%PSYTRFLOAT%
echo                         CPUNAME:%CPUNAME% CPUCLOCK:%CPUCLOCK%
echo.
echo                         AvgPSNR:%FormatedSumPSNR%
echo                         SSIM:%FormatedSumSSIM%db
echo                         FPS:%FormatedSumFps%
echo                         BR:%SumBitrate%
echo                         BF_USED:%SumBframeCount%
echo                         PF_USED:%SumPframeCount%
echo                         IF_USED:%SumIframeCount%
echo                         CPULOAD:%OverallCPULoad%
echo                        ͼ
set "OldStatSize="
set "NewStatSize="
echo Checking if filesize of statistic file increases after writing to detect access problems...

call :STATFILESIZE
set "OldStatSize=%statsize%"

setlocal enabledelayedexpansion
if /i "%OUTPUTFORMAT%"=="tab" (
	if not exist %STATISTICFILE% (
		echo x264.exe --!ENCODINGMODE! !QUANT! --ref !REF! --keyint 500 --min-keyint 0 --scenecut 40 --bframes !BF! --b-bias 0 --b-pyramid normal --direct auto --b-adapt 2 --sync-lookahead 25 --partitions all --8x8dct --no-fast-pskip --me !ME! --merange !MERANGE! --mvrange -1 --subme !SUB! --cabac --trellis !TRELLIS! --psy-rd !PSYRDFLOAT!:!PSYTRFLOAT! --weightp 2 --aq-mode !AQ-MODE! --aq-strength !AQ-STRENGTH! --nr 0 --deadzone-inter 21 --deadzone-intra 11 --cqm flat --threads auto --sar 1:1 --deblock -1:-1 --psnr --ssim --colormatrix undef>!STATISTICFILE!
		echo.>>!STATISTICFILE!
		echo [NR]!JobCounter!	[QUANTIZATION]!QUANT!	[SUBME]!SUB!	[REF]!REF!	[BFRAMES]!BF!	[PSY-RD]!PSYRDFLOAT!:!PSYTRFLOAT!	[ME]!ME!	[MERANGE]!MERANGE!	[TRELLIS]!TRELLIS!	[CPULOAD]!OverallCPULoad!	[AvgPSNR]!FormatedSumPSNR!	[SSIM]!FormatedSumSSIM!db	[FPS]!FormatedSumFps!	[BR]!SumBitrate!	[BF_USED]!SumBframeCount!	[PF_USED]!SumPframeCount!	[IF_USED]!SumIframeCount!	[ENCODINGMODE]!ENCODINGMODE!	[AQ-MODE]!AQ-MODE!	[AQ-STRENGTH]!AQ-STRENGTH!	[CPUNAME]!CPUNAME!	[CPUCLOCK]!CPUCLOCK!>>!STATISTICFILE!
	) else (
		echo [NR]!JobCounter!	[QUANTIZATION]!QUANT!	[SUBME]!SUB!	[REF]!REF!	[BFRAMES]!BF!	[PSY-RD]!PSYRDFLOAT!:!PSYTRFLOAT!	[ME]!ME!	[MERANGE]!MERANGE!	[TRELLIS]!TRELLIS!	[CPULOAD]!OverallCPULoad!	[AvgPSNR]!FormatedSumPSNR!	[SSIM]!FormatedSumSSIM!db	[FPS]!FormatedSumFps!	[BR]!SumBitrate!	[BF_USED]!SumBframeCount!	[PF_USED]!SumPframeCount!	[IF_USED]!SumIframeCount!	[AQ-MODE]!AQ-MODE!	[AQ-STRENGTH]!AQ-STRENGTH!	[CPUNAME]!CPUNAME!	[CPUCLOCK]!CPUCLOCK!>>!STATISTICFILE!
	)
)
if /i "%OUTPUTFORMAT%"=="csv" (
	if not exist %STATISTICFILE% (
		echo "x264.exe";"--!ENCODINGMODE! !QUANT!";"--ref !REF!";"--keyint 500";"--min-keyint 0";"--scenecut 40";"--bframes !BF!";"--b-bias 0";"--b-pyramid normal";"--direct auto";"--b-adapt 2";"--sync-lookahead 25";"--partitions all";"--8x8dct";"--no-fast-pskip";"--me !ME!";"--merange !MERANGE!";"--mvrange -1";"--subme !SUB!";"--cabac";"--trellis !TRELLIS!";"--psy-rd !PSYRDFLOAT!:!PSYTRFLOAT!";"--weightp 2";"--aq-mode !AQ-MODE!";"--aq-strength !AQ-STRENGTH!";"--nr 0";"--deadzone-inter 21";"--deadzone-intra 11";"--cqm flat";"--threads auto";"--sar 1:1";"--deblock -1:-1";"--psnr";"--ssim";"--colormatrix undef">!STATISTICFILE!
		echo.>>!STATISTICFILE!
		echo "NR";"QUANTIZATION";"SUBME";"REF";"BFRAMES";"PSY-RD";"ME";"MERANGE";"TRELLIS";"CPULOAD";"AvgPSNR";"SSIM";"FPS";"BR";"BF_USED";"PF_USED";"IF_USED";"ENCODINGMODE";"AQ-MODE";"AQ-STRENGTH";"CPUNAME";"CPUCLOCK">>!STATISTICFILE!
		echo "!JobCounter!";"!QUANT!";"!SUB!";"!REF!";"!BF!";"!PSYRDFLOAT!:!PSYTRFLOAT!";"!ME!";"!MERANGE!";"!TRELLIS!";"!OverallCPULoad!";"!FormatedSumPSNR!";"!FormatedSumSSIM!";"!FormatedSumFps!";"!SumBitrate!";"!SumBframeCount!";"!SumPframeCount!";"!SumIframeCount!";"!ENCODINGMODE!";"!AQ-MODE!";"!AQ-STRENGTH!";"!CPUNAME!";"!CPUCLOCK!">>!STATISTICFILE!
	) else (
		echo "!JobCounter!";"!QUANT!";"!SUB!";"!REF!";"!BF!";"!PSYRDFLOAT!:!PSYTRFLOAT!";"!ME!";"!MERANGE!";"!TRELLIS!";"!OverallCPULoad!";"!FormatedSumPSNR!";"!FormatedSumSSIM!";"!FormatedSumFps!";"!SumBitrate!";"!SumBframeCount!";"!SumPframeCount!";"!SumIframeCount!";"!ENCODINGMODE!";"!AQ-MODE!";"!AQ-STRENGTH!";"!CPUNAME!";"!CPUCLOCK!">>!STATISTICFILE!
	)
)
endlocal
call :STATFILESIZE
set "NewStatSize=%statsize%"

if "%OldStatSize%"=="%NewStatSize%" (
	cls
	COLOR 87
	call :LOGO
	echo.
	echo.
	echo WRITE ERROR!!! PROBLEMS WRITING VALUES TO STATISTICFILE:
	echo.
	echo %STATISTICFILE%
	echo.
	echo                         ͻ
	echo                         Hit a [KEY] to save and recover current job laterͼ
	PAUSE >nul
	REM call :RECOVER
	EXIT
)
GOTO :EOF



:STATFILESIZE
set statnamecnt=1
set statsizecnt=0
set statsize=0
if not exist %STATISTICFILE% goto :EOF
:STATSIZEINC
set /a statnamecnt=statnamecnt+1
set /a statsizecnt=statnamecnt-1
for /f "tokens=%statsizecnt%, %statnamecnt%" %%a in ('dir %STATISTICFILE%') do (
	if /i "%%b"==%STATFILENAME% (
		set "statsize=%%a"
	)
)
if "%statsize%"=="0" goto :STATSIZEINC
goto :EOF



:SHOWEFFECT
set eff=0
:SHOW
set /a eff=eff+1
echo %random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%
echo %random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%
echo %random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%
echo %random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%
echo %random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%%random%
cls
if %eff% lss %1 goto :SHOW
goto :EOF



:HELP
set "HelpUsed=0"
setlocal enabledelayedexpansion
set "HelpTopic="
set "HelpInput="
set "HelpInput=%~1"
if /i "%HelpInput:~0,4%" == "help" (
	for /f "tokens=1,2" %%a in ("%HelpInput%") do (set "HelpTopic=%%b")
) else (
	endlocal & set "HelpUsed=0" & goto :EOF
)
if not defined HelpTopic (endlocal & set HelpUsed=1 & goto :EOF)

if "%HelpTopic%"=="0" set "HelpTopic=--REFFRAMES"
if "%HelpTopic%"=="1" set "HelpTopic=--REFFRAMES"
if "%HelpTopic%"=="2" set "HelpTopic=--BFRAMES"
if "%HelpTopic%"=="3" set "HelpTopic=--BFRAMES"
if "%HelpTopic%"=="4" set "HelpTopic=--QUANTIZATION"
if "%HelpTopic%"=="5" set "HelpTopic=--QUANTIZATION"
if "%HelpTopic%"=="6" set "HelpTopic=--SUBME"
if "%HelpTopic%"=="7" set "HelpTopic=--SUBME"
if /i "%HelpTopic%"=="a" set "HelpTopic=--PSY-RD"
if /i "%HelpTopic%"=="b" set "HelpTopic=--PSY-RD"
if /i "%HelpTopic%"=="c" set "HelpTopic=--PSY-RD"
if /i "%HelpTopic%"=="d" set "HelpTopic=--ME"
if /i "%HelpTopic%"=="e" set "HelpTopic=--MERANGE"
if /i "%HelpTopic%"=="f" set "HelpTopic=--TRELLIS"
if /i "%HelpTopic%"=="g" set "HelpTopic=--ENCODINGMODE"
if /i "%HelpTopic%"=="h" set "HelpTopic=--AQ-MODE"
if /i "%HelpTopic%"=="i" set "HelpTopic=--AQ-MODE"
if /i "%HelpTopic%"=="j" set "HelpTopic=--CPULOADTHRESHOLD"
if /i "%HelpTopic%"=="k" set "HelpTopic=--OUTPUTFORMAT"
if /i "%HelpTopic%"=="l" set "HelpTopic=--SAVETMPFILES"

for /f "delims=] skip=2" %%a in ('find /n /i "%HelpTopic%" "%cd%\readme.txt"') do (if not defined HelpPos (set "HelpPos=%%a"))
set "HelpPos=%HelpPos:~1%"
if defined HelpPos set /a HelpPos=HelpPos-1
if not defined HelpPos (endlocal & set HelpUsed=1 & goto :EOF)
set /a HelpPos=HelpPos*1
echo %HelpTopic% & PAUSE
echo %HelpPos% & PAUSE
cls
if "%HelpPos%"=="0" (endlocal & set HelpUsed=1 & goto :EOF)
echo.
call :LOGO
echo.
for /f "skip=%HelpPos% usebackq delims=" %%a in ("%cd%\readme.txt") do (
	if "%%a"=="_______________________________________________________________________________" (set "NoMoreToScreen=1")
	if not defined NoMoreToScreen (if "%%a"=="	" (echo.) else (echo %%a))
)
REM more /e +%HelpPos% "%cd%\readme.txt"
echo.
echo                         ͻ
echo                         Hit a [KEY] to return to main menueͼ
PAUSE >nul
endlocal & set HelpUsed=1 & goto :EOF
	


:LOGO
echo                        [X-QuaSaT 1.6.11]߿
echo                        ///////////////////////////////////// x264 Quality and Speed analyse Tool \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
echo                                         
if "%~1"=="pausetxt" echo                                ^> Execute ^"^(Un^)PauseMe.cmd^" in program folder to pause skript an continue later ^<
goto :EOF